package com.biganto.visual.roompark.presentation.screen.web_cam

import android.os.Bundle
import android.view.View
import androidx.core.os.bundleOf
import butterknife.BindView
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.base.IBottomNavigation
import com.biganto.visual.roompark.base.RoomParkApplication
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.conductor.BigantoBaseController
import com.biganto.visual.roompark.presentation.screen.albums.AlbumsScreen
import com.biganto.visual.roompark.presentation.screen.albums.AlbumsScreenPresenter
import com.biganto.visual.roompark.presentation.screen.albums.AlbumsScreenViewState
import com.google.android.exoplayer2.SimpleExoPlayer
import com.google.android.exoplayer2.ui.PlayerView
import javax.inject.Inject


/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */

const val SELECTED_ALBUM_INDEX_KEY = "SELECTED_ALBUM_INDEX"

class AlbumsScreenController :
    BigantoBaseController<AlbumsScreenViewState
            , AlbumsScreen
            , AlbumsScreenPresenter>
   , AlbumsScreen {

    constructor(args: Bundle):super(args)

    constructor(id: Int) : super(bundleOf(SELECTED_ALBUM_INDEX_KEY to id))

    @BindView(R.id.webCamPlayerView)
    lateinit var playerView:PlayerView

    lateinit var player:SimpleExoPlayer


    override fun onViewBound(v: View) {
        toolBar.hideAll()
        bottomNavigation.hide()
    }

    override fun injectDependencies() {
        getComponent()
    }

    @Inject
    override lateinit var injectedPresenter: AlbumsScreenPresenter


//    @Inject
//    lateinit var snacky:ISnackBarProvider

    lateinit var rpActivity: RoomParkMainActivity

    fun getComponent() = DaggerAlbumsScreenComponent
        .factory()
        .create(RoomParkApplication.component
            ,activity as RoomParkMainActivity
            ,args.getInt(SELECTED_ALBUM_INDEX_KEY))
        .inject(this)

//    @Inject
//    lateinit var ac: RoomParkMainActivity

    @Inject
    lateinit var bottomNavigation: IBottomNavigation

    override fun render(viewState: AlbumsScreenViewState) {
        when(viewState){
            is AlbumsScreenViewState.Idle -> render(viewState)
            is AlbumsScreenViewState.AlbumsSelected -> render(viewState)
            is AlbumsScreenViewState.AlbumsListLoaded-> render(viewState)
            is AlbumsScreenViewState.SomeError -> render(viewState)
        }
    }

    private fun render(viewState: AlbumsScreenViewState.Idle){

    }

    private fun render(viewState: AlbumsScreenViewState.SomeError) =
        showError(viewState.exception)

    private fun render(viewState: AlbumsScreenViewState.AlbumsListLoaded){

    }

    private fun render(viewState: AlbumsScreenViewState.AlbumsSelected){

    }


    override fun getLayoutId(): Int = R.layout.albums_screen

}